Attribute VB_Name = "Glass_Tower"
'Skyscraper 1.1 Alpha - Glass Tower Code
'Copyright 2005 Ryan Thoryk
'http://www.tliquest.net/skyscraper
'http://sourceforge.net/projects/skyscraper
'Contact - ryan@tliquest.net

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
'This module is temporary, since the Glass Tower-specific data
'will be exported into a data file

Private AltitudeCheck As Single
Option Explicit

Public Sub GT_LoadTextures()
  TextureFactory.LoadTexture App.Path + "\data\brick1.jpg", "BrickTexture"
  TextureFactory.LoadTexture App.Path + "\data\LobbyFront.jpg", "LobbyFront"
  TextureFactory.LoadTexture App.Path + "\data\windows11c.jpg", "MainWindows"
  TextureFactory.LoadTexture App.Path + "\data\granite.jpg", "Granite"
  'TextureFactory.LoadTexture App.Path+"\data\marbl3.jpg", "Marble3"
  'TextureFactory.LoadTexture App.Path+"\data\text12.jpg", "Marble3"
  TextureFactory.LoadTexture App.Path + "\data\symb5.jpg", "Marble3"
  TextureFactory.LoadTexture App.Path + "\data\marb047.jpg", "Marble4"
  TextureFactory.LoadTexture App.Path + "\data\elev1.jpg", "Elev1"
  TextureFactory.LoadTexture App.Path + "\data\textur15.jpg", "Wood1"
  TextureFactory.LoadTexture App.Path + "\data\text16.jpg", "Wood2"
  'TextureFactory.LoadTexture App.Path+"\data\text12.jpg", "Wall1"
  TextureFactory.LoadTexture App.Path + "\data\marbl3.jpg", "Wall1"
  TextureFactory.LoadTexture App.Path + "\data\marb123.jpg", "Wall2"
  'TextureFactory.LoadTexture App.Path+"\data\marbl3.jpg", "Wall2"
  'TextureFactory.LoadTexture App.Path+"\data\marb056.jpg", "Wall3"
  TextureFactory.LoadTexture App.Path + "\data\cutston.jpg", "Ceiling1"
  TextureFactory.LoadTexture App.Path + "\data\text12.jpg", "Wall3"
  TextureFactory.LoadTexture App.Path + "\data\text16.jpg", "ElevDoors"
  TextureFactory.LoadTexture App.Path + "\data\marb148.jpg", "ElevExtPanels"
  TextureFactory.LoadTexture App.Path + "\data\mason01.jpg", "Concrete"
  TextureFactory.LoadTexture App.Path + "\data\text13.jpg", "Stairs"
  TextureFactory.LoadTexture App.Path + "\data\wooddoor3.jpg", "Door1"
  TextureFactory.LoadTexture App.Path + "\data\wooddoor1.jpg", "Door2"
  TextureFactory.LoadTexture App.Path + "\data\servicedoor2.jpg", "StairsDoor"
  TextureFactory.LoadTexture App.Path + "\data\miscdoor8.jpg", "StairsDoor2"
  TextureFactory.LoadTexture App.Path + "\data\button1.jpg", "CallButtonsTex"
  TextureFactory.LoadTexture App.Path + "\data\sidewalk1r.jpg", "Road1"
  TextureFactory.LoadTexture App.Path + "\data\walkway.jpg", "Walkway"
  TextureFactory.LoadTexture App.Path + "\data\sidewalkcorner1.jpg", "Road2"
  TextureFactory.LoadTexture App.Path + "\data\sidewalkcorner2.jpg", "Road3"
  TextureFactory.LoadTexture App.Path + "\data\sidewalkcorner3.jpg", "Road4"
  TextureFactory.LoadTexture App.Path + "\data\roadfull.jpg", "Road5"
  TextureFactory.LoadTexture App.Path + "\data\windows08.jpg", "Windows8"
  TextureFactory.LoadTexture App.Path + "\data\windows11.jpg", "Windows11"
  TextureFactory.LoadTexture App.Path + "\data\downtown.jpg", "Downtown"
  TextureFactory.LoadTexture App.Path + "\data\suburbs.jpg", "Suburbs"
      
  TextureFactory.LoadTexture App.Path + "\data\top.jpg", "SkyTop"
  TextureFactory.LoadTexture App.Path + "\data\bottom.jpg", "SkyBottom"
  TextureFactory.LoadTexture App.Path + "\data\left.jpg", "SkyLeft"
  TextureFactory.LoadTexture App.Path + "\data\right.jpg", "SkyRight"
  TextureFactory.LoadTexture App.Path + "\data\front.jpg", "SkyFront"
  TextureFactory.LoadTexture App.Path + "\data\back.jpg", "SkyBack"
  TextureFactory.LoadTexture App.Path + "\objects\benedeti.jpg", "ColumnTex", , , TV_COLORKEY_NO
  TextureFactory.LoadTexture App.Path + "\data\plaque.jpg", "Plaque"
  TextureFactory.LoadTexture App.Path + "\data\floorsign.jpg", "FloorSign"
  TextureFactory.LoadTexture App.Path + "\data\floorsignballroom.jpg", "FloorSignBallroom"
  TextureFactory.LoadTexture App.Path + "\data\floorsignbalcony.jpg", "FloorSignBalcony"
  TextureFactory.LoadTexture App.Path + "\data\floorsignhotel.jpg", "FloorSignHotel"
  TextureFactory.LoadTexture App.Path + "\data\floorsignlobby.jpg", "FloorSignLobby"
  TextureFactory.LoadTexture App.Path + "\data\floorsignmaint.jpg", "FloorSignMaint"
  TextureFactory.LoadTexture App.Path + "\data\floorsignmez.jpg", "FloorSignMez"
  TextureFactory.LoadTexture App.Path + "\data\floorsignmechanical.jpg", "FloorSignMechanical"
  TextureFactory.LoadTexture App.Path + "\data\floorsignobservatory.jpg", "FloorSignObservatory"
  TextureFactory.LoadTexture App.Path + "\data\floorsignoffices.jpg", "FloorSignOffices"
  TextureFactory.LoadTexture App.Path + "\data\floorsignpool.jpg", "FloorSignPool"
  TextureFactory.LoadTexture App.Path + "\data\floorsignresidential.jpg", "FloorSignResidential"
  TextureFactory.LoadTexture App.Path + "\data\floorsignroof.jpg", "FloorSignRoof"
  TextureFactory.LoadTexture App.Path + "\data\floorsignskylobby.jpg", "FloorSignSkylobby"
  
  'loads all the floor indicator/button pictures
  TextureFactory.LoadTexture App.Path + "\data\floorindicators\L.jpg", "ButtonL"
  TextureFactory.LoadTexture App.Path + "\data\floorindicators\M.jpg", "ButtonM"
  TextureFactory.LoadTexture App.Path + "\data\floorindicators\R.jpg", "ButtonR"
  TextureFactory.LoadTexture App.Path + "\data\floorindicators\open.jpg", "ButtonOpen"
  TextureFactory.LoadTexture App.Path + "\data\floorindicators\close.jpg", "ButtonClose"
  TextureFactory.LoadTexture App.Path + "\data\floorindicators\stop.jpg", "ButtonStop"
  TextureFactory.LoadTexture App.Path + "\data\floorindicators\alarm.jpg", "ButtonAlarm"
  TextureFactory.LoadTexture App.Path + "\data\floorindicators\cancel.jpg", "ButtonCancel"
  Dim i As Integer
  For i = 2 To 138
  DoEvents
  TextureFactory.LoadTexture App.Path + "\data\floorindicators\" + Mid$(Str$(i), 2) + ".jpg", "Button" + Mid$(Str$(i), 2)
  Next i
End Sub

Public Sub GT_Globals()
'Process building-wide specific items
CameraDefAltitude = 10
ElevatorShafts = 1
TotalFloors = 137 '138 total floors
Basements = 0
Elevators = 1
PipeShafts = 1
StairsNum = 1
CameraStartFloor = 0
CameraStartPositionX = 0
CameraStartPositionZ = -130
CameraStartDirection = Vector(0, 10, 90)
CameraStartRotation = Vector(0, 0, 0)
End Sub

Public Sub GT_ProcessFloors()
Dim i As Integer
AltitudeCheck = 0
'Lobby
i = 0
With Floor(i)
    .Height = 75
    .CrawlSpaceHeight = 0
    .DoorHeight = 19.5
    .Altitude = AltitudeCheck
    AltitudeCheck = AltitudeCheck + .Height + .CrawlSpaceHeight

    'Floor
    '.AddFloor "Marble4", -160, -150, 160, 150, 0, 0, 0, False
    .AddFloor "Marble4", -600, -600, 600, 600, 0, 0, 0, False
    
    'Ceiling
    '.AddFloor "Ceiling1", -160, -150, 160, 150, .Height - 0.05, 0, 0, False
    
    'Lobby Front
    'back wall
    '.AddWall "LobbyFront", -82.41, 196.74, 96.74, 121.17, .Height, 0, -3, 0, True
    .AddWall "LobbyFront", -36.81, 177.2, 96.74, 121.17, .Height, 0, -3, 0, True
    'back left wall
    '.AddWall "LobbyFront", -82.41, 196.74, -100, 103.58, .Height, 0, -3, 0, True
    'back right wall
    .AddWall "LobbyFront", 96.74, 121.17, 87.622, 103.58, .Height, 0, -3, 0, True
    'back right cover wall
    .AddWall "LobbyFront", 87.622, 103.58, 100, 103.58, .Height, 0, -3, 0, True
    'left upper wall
    '.AddWall "LobbyFront", -100, 103.58, -180.13, 13.68, .Height, 0, -3, 0, True
    .AddWall "LobbyFront", -36.81, 177.2, -180.13, 13.68, .Height, 0, -3, 0, True
    'left lower wall
    .AddWall "LobbyFront", -180.13, 13.68, -163.19, -43.65, .Height, 0, -3, 0, True
    'front left wall
    .AddWall "LobbyFront", -163.19, -43.65, -217.26, -123.13, .Height, 0, -3, 0, True
    'front center wall
    .AddWall "LobbyFront", -217.26, -123.13, -23.13, -119.87, .Height, 0, -3, 0, True
    'front right wall
    .AddWall "LobbyFront", -23.13, -119.87, -32.9, -99.674, .Height, 0, -3, 0, True
    'front right cover wall
    .AddWall "LobbyFront", -32.9, -99.674, -25.733, -101.63, .Height, 0, -3, 0, True
    'glass elevator wall
    .AddWall "LobbyFront", -25.733, -101.63, 40.72, -101.63, .Height, 0, -3, 0, True
    'right bottom wall
    .AddWall "LobbyFront", 40.72, -101.63, 171.66, -29.97, .Height, 0, -3, 0, True
    'right top wall
    .AddWall "LobbyFront", 171.66, -29.97, 100, 103.58, .Height, 0, -3, 0, True

End With

'floors 2 to 40
For i = 1 To 39
With Floor(i)
    DoEvents
    
    .Height = 25
    .CrawlSpaceHeight = 7
    .DoorHeight = 19.5
    .Altitude = AltitudeCheck
    AltitudeCheck = AltitudeCheck + .Height + .CrawlSpaceHeight

    'Floor
    '.AddFloor "Granite", -160, 150, 160, -150, 0, 0, 0, False
    
    'Ceiling
    '.AddFloor "Marble3", -160, 150, 160, -150, .Height - 0.5, 0, 0, False
    
    'Crawlspace bottom
    '.AddCrawlSpaceFloor "BrickTexture", -160, 150, 160, -150, 0, 0, 0
    
    'Crawlspace top
    '.AddCrawlSpaceFloor "BrickTexture", -160, 150, 160, -150, .CrawlSpaceHeight - 0.05, 0, 0
    
    'Crawlspace walls
    '.AddCrawlSpaceWall "BrickTexture", -160, -150, 160, -150, .CrawlSpaceHeight, 0, 0, 0
    '.AddCrawlSpaceWall "BrickTexture", 160, -150, 160, 150, .CrawlSpaceHeight, 0, 0, 0
    '.AddCrawlSpaceWall "BrickTexture", 160, 150, -160, 150, .CrawlSpaceHeight, 0, 0, 0
    '.AddCrawlSpaceWall "BrickTexture", -160, 150, -160, -150, .CrawlSpaceHeight, 0, 0, 0

    'External windows/walls
    'back wall
    '.AddWall "MainWindows", -82.41, 196.74, 96.74, 121.17, .Height, 0, 0, 0, True
    .AddWall "MainWindows", -36.81, 177.2, 96.74, 121.17, .Height, 0, 0, 0, True
    'back left wall
    '.AddWall "MainWindows", -82.41, 196.74, -100, 103.58, .Height, 0, 0, 0, True
    'back right wall
    .AddWall "MainWindows", 96.74, 121.17, 87.622, 103.58, .Height, 0, 0, 0, True
    'back right cover wall
    .AddWall "MainWindows", 87.622, 103.58, 100, 103.58, .Height, 0, 0, 0, True
    'left upper wall
    '.AddWall "MainWindows", -100, 103.58, -180.13, 13.68, .Height, 0, 0, 0, True
    .AddWall "MainWindows", -36.81, 177.2, -180.13, 13.68, .Height, 0, 0, 0, True
    'left lower wall
    .AddWall "MainWindows", -180.13, 13.68, -163.19, -43.65, .Height, 0, 0, 0, True
    'front left wall
    .AddWall "MainWindows", -163.19, -43.65, -217.26, -123.13, .Height, 0, 0, 0, True
    'front center wall
    .AddWall "MainWindows", -217.26, -123.13, -23.13, -119.87, .Height, 0, 0, 0, True
    'front right wall
    .AddWall "MainWindows", -23.13, -119.87, -32.9, -99.674, .Height, 0, 0, 0, True
    'front right cover wall
    .AddWall "MainWindows", -32.9, -99.674, -25.733, -101.63, .Height, 0, 0, 0, True
    'glass elevator wall
    .AddWall "Ceiling1", -25.733, -101.63, 40.72, -101.63, .Height, 0, 0, 0, True
    'right bottom wall
    .AddWall "MainWindows", 40.72, -101.63, 171.66, -29.97, .Height, 0, 0, 0, True
    'right top wall
    .AddWall "MainWindows", 171.66, -29.97, 100, 103.58, .Height, 0, 0, 0, True

    End With
Next i

End Sub

Sub GT_ProcessElevators()
Elevator(1).ElevatorSpeed = 1.5
Elevator(1).Acceleration = 0.07
Elevator(1).OpenSpeed = 1.5

Elevator(1).CreateElevator 12.5, 30, 0, 0

End Sub

